<?php
declare(strict_types=1);

namespace FiloBlu\Core\Model;

use FiloBlu\Core\Api\Data\FbOrderExtensionAttrInterface;
use FiloBlu\Core\Api\Data\FbOrderExtensionAttrInterfaceFactory;
use FiloBlu\Core\Model\ResourceModel\FbOrderExtensionAttr\Collection;
use Magento\Framework\Api\DataObjectHelper;
use Magento\Framework\Model\AbstractModel;
use Magento\Framework\Model\Context;
use Magento\Framework\Registry;

class FbOrderExtensionAttr extends AbstractModel
{

    protected $_eventPrefix = 'fb_extensionattributes_order';
    protected $fborderextensionattrDataFactory;

    protected $dataObjectHelper;


    /**
     * @param Context $context
     * @param Registry $registry
     * @param FbOrderExtensionAttrInterfaceFactory $fborderextensionattrDataFactory
     * @param DataObjectHelper $dataObjectHelper
     * @param ResourceModel\FbOrderExtensionAttr $resource
     * @param Collection $resourceCollection
     * @param array $data
     */
    public function __construct(
        Context     $context,
        Registry          $registry,
        FbOrderExtensionAttrInterfaceFactory $fborderextensionattrDataFactory,
        DataObjectHelper                     $dataObjectHelper,
        ResourceModel\FbOrderExtensionAttr   $resource,
        Collection                           $resourceCollection,
        array                                $data = []
    )
    {
        $this->fborderextensionattrDataFactory = $fborderextensionattrDataFactory;
        $this->dataObjectHelper = $dataObjectHelper;
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }

    /**
     * Retrieve fborderextensionattr model with fborderextensionattr data
     * @return FbOrderExtensionAttrInterface
     */
    public function getDataModel()
    {
        $fborderextensionattrData = $this->getData();

        $fborderextensionattrDataObject = $this->fborderextensionattrDataFactory->create();
        $this->dataObjectHelper->populateWithArray(
            $fborderextensionattrDataObject,
            $fborderextensionattrData,
            FbOrderExtensionAttrInterface::class
        );

        return $fborderextensionattrDataObject;
    }
}

